<?php
//Definindo Constantes
require_once ROOTPATH.'/modules/calendar/constants.php';

require_once ROOTPATH.'/modules/calendar/interceptors/Helpers.php';

class DBMapping extends Helpers {	
           
    public function encodeCreateSchedulable( &$uri , &$params , &$criteria , $original ){			
        $params['type_id'] = EVENT_ID;
              
        $params['rangeStart'] = gmdate( 'd-m-Y' , (int)($params['startTime'] / 1000) );

    //        if( !isset( $new['repeat'] ))
    //            $new['range_end'] = '7287926400'; // 12/12/2200
    //        else
            $params['rangeEnd'] = gmdate( 'd-m-Y' , (int)($params['endTime'] / 1000) );
            ///////////////////////////////////////////////////////////////////

            $params['dtstamp'] = (isset($params['dtstamp'])) ? $params['dtstamp'] :time().'000'; 
            $params['lastUpdate'] = (isset($params['lastUpdate'])) ? $params['lastUpdate'] :time().'000'; 
            $params['type'] = EVENT_ID;
            $params['uid'] = isset($params['uid']) ? $params['uid'] : $this->_makeUid();
            
        }	
    public function encodeCreateAlarm( &$uri , &$params , &$criteria , $original ){
      	
        if(!isset($params['schedulable']) || !isset($params['rangeStart']) || !isset($params['rangeEnd']) )
        {
            $participant = Controller::read( array( 'concept' => 'participant' , 'id' => $params['participant'] ) , array('schedulable')  ); 
            $schedulable = Controller::read( array( 'concept' => 'schedulable' , 'id' => $participant['schedulable'] ) , array('startTime' , 'endTime' )  );

            $params['schedulable'] = $participant['schedulable'];
            $params['rangeStart'] = gmdate( 'd-m-Y' , strtotime('- '.$params['time'].' '.self::codeAlarmUnit($params['unit']) , (int)($schedulable['startTime'] / 1000)));
            $params['rangeEnd'] = gmdate( 'd-m-Y' ,(int)($schedulable['endTime'] / 1000));
        }
        
        $params['type']	= self::codeAlarmType($params['type']);
        
        }  
	
	public function encodeUpdateAlarm( &$uri , &$params , &$criteria , $original ){
            if(isset($params['type']))
                $params['type'] = self::codeAlarmType($params['type']);
	}
        
    public function encodeCreateAttachment( &$uri , &$params , &$criteria , $original ){
        $params['source'] = base64_encode( $params['source'] );
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
    public function encodeSignatureAlarmType( &$uri , &$params , &$criteria , $original ){
	$params['type']	= self::codeAlarmType($params['type']);
    }  
	

    public function insertOwnerLink (&$uri , &$params , &$criteria , $original ){
            $params['owner'] = Config::me('uidNumber'); 
      }  
       
    public function encodeServiceUser (&$uri , &$params , &$criteria , $original ){
           if(isset($params['isExternal']) && $params['isExternal'] == '1')
                $uri['service'] = 'PostgreSQL'; 
    }  
      
   public function findSchedulable( &$uri , &$params , &$criteria , $original )
   {
       if(isset($criteria['filter'][3][1]) && $criteria['filter'][3][1] == 'calendar')
       {
         $select = 'calendar_object.id as id ,calendar_object.cal_uid as "uid" , calendar_object.type_id as "type", calendar_object.dtstart as "startTime", calendar_object.summary as "summary", calendar_object.description as "description", calendar_object.dtend as "endTime" , calendar_object.location as "location", calendar_object.allday as "allDay", calendar_object.transp as "transparent", calendar_object.class_id as "class", calendar_object.repeat as "repeat", calendar_object.range_start as "rangeStart",calendar_object.range_end as "rangeEnd", calendar_object.last_update as "lastUpdate", calendar_object.dtstamp as "dtstamp", calendar_object.sequence as "sequence",  calendar_object.tzid as "timezone" ,calendar_to_calendar_object.calendar_id as calendar';
         $sql = " SELECT $select FROM calendar_to_calendar_object , calendar_object WHERE (range_start >= '".$criteria['filter'][1][2]."' AND range_end <= '".$criteria['filter'][2][2]."' AND calendar_to_calendar_object.calendar_id IN ('".  implode('\',\'', $criteria['filter'][3][2])."')) AND calendar_to_calendar_object.calendar_object_id = calendar_object.id";
         $params = Controller::service('PostgreSQL')->execResultSql($sql);
         $params = self::deepnessFindEvent( &$uri , &$params , &$criteria , $original);
         return false;
       }
   }
   
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

    public function updateCalendar( &$uri , &$params , &$criteria , $original ){
        if( isset($params['calendar']))
        { 
            $calendarObjects = self::schedulable2calendarToObject( $uri['id'] );
            $params2['calendar'] = $params['calendar']; 
           
            foreach ($calendarObjects as $calendarObject)
                Controller::update( array('concept' => 'calendarToSchedulable' , 'id' => $calendarObject['calendar_to_calendar_object']) , $params2 );
         
            unset( $params['calendar'] );
            
            if(count($params) < 1) return false;
        }
    } 
     
//Encode Update

    public function encodeUpdateSchedulable( &$uri , &$params , &$criteria , $original ){	
        if(isset($params['startTime']))
	       	$params['rangeStart'] = gmdate( 'd-m-Y' , (int)($params['startTime'] / 1000) );
	if(isset($params['endTime']))
   		$params['rangeEnd'] = gmdate( 'd-m-Y' , (int)($params['endTime'] / 1000) );       
        	
                
     }        
     
    static function putEvent(&$uri , &$result , &$criteria , $original)
    {          
            if(Config::module('useCaldav')) //Ignorar Put dos eventos ja vindos do caldav
            {
                require_once ROOTPATH.'/modules/calendar/interceptors/DAViCalAdapter.php';

                $eventID = (isset($result['id'])) ? $result['id'] : $uri['id'];
                $event = Controller::read( array( 'concept' => 'schedulable' , 'id' => $eventID ) );

                $participants = Controller::find( array( 'concept' => 'participant' ) , false ,array( 'filter' => array('=' ,  'schedulable' ,  $eventID) )); 

                if(is_array($participants) && count($participants) > 0)
                    foreach ($participants as $ii => $vv)
                    {
                        if($vv['isExternal'] == 1 )
                            $participants[$ii]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $vv['user'] , 'service' => 'PostgreSQL' ) );
                        else
                           $participants[$ii]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $vv['user'] ));
                    } 

                $event['URI']['concept'] = 'schedulable';
                $event['participants'] = $participants;
               
                $ical = Controller::format( array( 'service' => 'iCal' ) , array($event) );                  
                $calendars =  self::schedulable2calendarToObject($original['properties']['id']); //Busca os calendarios do usuario logado que contenham o evento
                if( is_array($calendars) )
                    foreach ($calendars as $calendar)
                        DAViCalAdapter::putIcal($ical , array('uid' => $event['uid'] , 'collection' => $calendar['calendar_location'] ));
            }
    } 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    public function verifyCalendarLocation( &$uri , &$params , &$criteria , $original ){
        if(!isset($params['location']))
            $params['location'] = $params['name'];
    } 
    
      
    //TODO: Remover apos suporte a ManytoMany na api 
    public function createCalendarToSchedulable( &$uri , &$result , &$criteria , $original ){		

       Controller::create(array('concept' => 'calendarToSchedulable'), array('calendar' => $original['properties']['calendar'], 'schedulable' => $result['id'] ));
            
   }   
     
    //TODO: Remover apos suporte a deepness na api 
    public function deepnessFindEvent( &$uri , &$result , &$criteria , $original ){		
       
       if(isset($original['criteria']['deepness']))
       {
           foreach ($result as $i => $v)
           {
                if(isset($v['id']))
                {
                    $participants = Controller::find( array( 'concept' => 'participant' ) , false ,array( 'filter' => array('=', 'schedulable'  ,  $v['id']) )); 
                    
                    if(is_array($participants) && count($participants) > 0)
                    foreach ($participants as $ii => $vv)
                    {
                        if($vv['isExternal'] == 1 )
                            $participants[$ii]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $vv['user'] , 'service' => 'PostgreSQL' ) );
                        else
                           $participants[$ii]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $vv['user'] ));
                    
                        if($participants[$ii]['user']['id'] == Config::me('uidNumber'))
                           $participants[$ii]['alarms'] = Controller::find( array( 'concept' => 'alarm' ) , null , array('filter' => array('AND' , array('=', 'participant' ,$vv['id'] ) ,array('=' , 'schedulable', $v['id'])) ) ); 
                    }       
                    $result[$i]['participants'] = $participants;
                }               
                
           }
       }
       
       return $result;
       
   } 
   
    //TODO: Remover apos suporte a deepness na api 
    public function deepnessReadEvent( &$uri , &$result , &$criteria , $original ){		
       
       if(isset($original['criteria']['deepness']))
       {
            if(isset($result['id']))
            {
                $participants = Controller::find( array( 'concept' => 'participant' ) , false ,array( 'filter' => array('=' ,  'schedulable' ,  $result['id']) )); 
                if(is_array($participants))
                    foreach ($participants as $ii => $vv)
                    {
                        if($vv['isExternal'] == 1 )
                            $participants[$ii]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $vv['user'] , 'service' => 'PostgreSQL' ) );
                        else
                           $participants[$ii]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $vv['user'] ));

                        if($participants[$ii]['user']['id'] == Config::me('uidNumber'))
                           $participants[$ii]['alarms'] = Controller::find( array( 'concept' => 'alarm' ) , null , array('filter' => array('AND' , array('=', 'participant' ,$vv['id'] ) ,array('=' , 'schedulable', $result['id'])) ) ); 
               }  

                $result['participants'] = $participants;
                }
       }
   } 
   
    //TODO: Remover apos suporte a deepness na api
    public function deepnessReadParticipant( &$uri , &$result , &$criteria , $original ){		
       
       if(isset($original['criteria']['deepness']))
       {
            if(isset($result['id']))
            {
                if($result['isExternal'] == 1 )
                    $result['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $result['user'] , 'service' => 'PostgreSQL' ) );
                else
                   $result['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $result['user'] ));
            }
       }

   } 
   
    //TODO: Remover apos suporte a deepness na api 
    public function deepnessFindParticipant( &$uri , &$result , &$criteria , $original ){		
       
       if(isset($original['criteria']['deepness']))
       {
           foreach ($result as $i => $v)
           {
                if(isset($v['id']))
                {
                    if($result[$i]['isExternal'] == 1 )
                        $result[$i]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $result[$i]['user'] , 'service' => 'PostgreSQL' ) );
                    else
                       $result[$i]['user'] = Controller::read( array( 'concept' => 'user' , 'id' => $result[$i]['user'] ));
                }
           }
       }
       
   } 
   
    //TODO: Remover apos suporte a deepness na api 
    public function deepnessReadCalendarSignature( &$uri , &$result , &$criteria , $original ){		
       
       if(isset($original['criteria']['deepness']))
            if(isset($result['calendar'])){
                $result['calendar'] = Controller::read( array( 'concept' => 'calendar' , 'id' => $result['calendar'])); 
				$result['defaultAlarms'] = Controller::find( array( 'concept' => 'calendarSignatureAlarm' ) , false ,array( 'filter' => array('=', 'calendarSignature'  ,  $result['id']) ));     
			}
            
   } 
   
     //TODO: Remover apos suporte a deepness na api 
    public function deepnessFindCalendarSignature( &$uri , &$result , &$criteria , $original ){		
       
      if(isset($original['criteria']['deepness']))
       {
           foreach ($result as $i => $v)
           {
                if(isset($v['calendar'])){
                    $result[$i]['calendar'] = Controller::read( array( 'concept' => 'calendar' , 'id' => $v['calendar'])); 
					$result[$i]['defaultAlarms'] = Controller::find( array( 'concept' => 'calendarSignatureAlarm' ) , false ,array( 'filter' => array('=', 'calendarSignature'  ,  $v['id']) ));     
				}
           }
       }
       
   } 
//Decode Find       
    public function decodeFindConcept( &$uri , &$result , &$criteria , $original ){		
	if($result && is_array($result) ) 
        {
            $m = array_flip(self::${$uri['concept'].'Map'});
            $new = array();
            foreach ($result as $i => $v)
                $new[$i] = self::parseConcept( $result[$i] , $m );


            $result = $new;
        }
    }
    
    public function decodeFindSchedulable( &$uri , &$result , &$criteria , $original ){		
	if($result && is_array($result) ) 
        {
            $m = array_flip(self::${$uri['concept'].'Map'});
            $m['calendar_id'] = 'calendar';
            $new = array();
            foreach ($result as $i => $v)
                $new[$i] = self::parseConcept( $result[$i] , $m );


            $result = $new;
        }
    }
	
	public function decodeSignatureAlarmType( &$uri , &$result , &$criteria , $original ){	
            if( is_array($result) )
            foreach($result as &$param)
                if(isset($param['type']))
                    $param['type'] = self::decodeAlarmType($param['type']);
	
    }
	
/////////////////////////////////////////////////////////////////////////
    
    static function dayAlarm( &$uri , &$params , &$criteria , $original ) {     
        if(isset($criteria['filter'][1]) && $criteria['filter'][1] == 'date')
        {
            $filter = array( 'AND', 
                      array( '='  , 'sent' , '0') ,  
                      array( '='  , 'type' ,  ALARM_ALERT) ,  
                      array( '>=' , 'rangeStart' , $criteria['filter'][2]) ,
                      array( '<=' , 'rangeEnd' , $criteria['filter'][2]) ); 

            //Busca os Alarmes no Range
            $al = Controller::find( array('concept' => 'alarm'), false ,array( 'filter' => $filter));
            
            if(is_array($al))
            foreach ($al as $i => $v)
            {
                $ev =  Controller::read( array( 'concept' => 'schedulable' , 'id' => $v['schedulable']) ) ;

                $unit = 0;
                switch (strtolower($v['unit'])) {
                        case 'm': $unit = 60; break;
                        case 'H': $unit = 3600; break;
                        case 'd': $unit = 216000; break; }
                
                  $al[$i]['sendTime'] = (((int)( $ev['startTime'] / 1000 )) - ( $v['time'] * $unit ));
                  $al[$i]['schedulable'] =   $ev;
                        
            }
            
            $params = $al;
            return false;
        }
    } 

    public function deleteSchedulable( &$uri , &$params , &$criteria , $original ){

       if(Config::module('useCaldav'))
            require_once ROOTPATH.'/modules/calendar/interceptors/DAViCalAdapter.php';

        $calendarsToSchedulable = self::schedulable2calendarToObject($uri['id']);
        if( !self::ownerSchedulable($uri['id']) )
        {
             foreach ($calendarsToSchedulable as $i => $v)
             {
                   Controller::delete(array('concept' => 'calendarToSchedulable' , 'id' => $v['calendar_to_calendar_object']));
                   
                   if(Config::module('useCaldav'))
                        DAViCalAdapter::deleteEvent($uri['id'], array('calendar' => $v['calendar_name']));
             }

             /* Seta o participante como rejeitado */
             Controller::update(array('concept' => 'participant'), array('status' => STATUS_CANCELLED) , 
             array('filter' => 
                 array('AND',
                        array('=' , 'user'  ,$_SESSION['wallet']['user']['uidNumber'] ),
                        array('=' , 'schedulable'  , $uri['id'] )
                     )));
            
            return false; /* Mata o restante da execuo */
        } 
        
        if(Config::module('useCaldav'))
            foreach ($calendarsToSchedulable as $i => $v)
                DAViCalAdapter::deleteEvent($uri['id'], array('calendar' => $v['calendar_name']));

     }

    public function deleteCalendarSignatureDependences( &$uri , &$params , &$criteria , $original ){
         $signature = Controller::read($uri,array('isOwner','calendar'));
            
        if($signature['isOwner'] == '1')
        {
           $calendarToSchedulables = Controller::find(array('concept' => 'calendarToSchedulable') , null , array('filter' => array('=' , 'calendar' , $signature['calendar'] )));
           
           $schedulables = array();
           if(is_array($calendarToSchedulables))
           foreach ($calendarToSchedulables as $key => $calendarToSchedulable) 
                 $schedulables[] = $calendarToSchedulable['schedulable'] ; 
            
	   if( !empty( $schedulables ) )
	      Controller::deleteALL(array('concept' => 'schedulable'),null , array('filter' => array('IN' , 'id' , $schedulables)));

           Controller::delete(array('concept' => 'calendar', 'id' => $signature['calendar']));
        }
        
     }

    public function createDefaultSignature( &$uri , &$result , &$criteria , $original ){
    		     
    //Caso uma busca no retorne nenhum resultado e foi buscado pelas assinaturas do usuario logado apenas
    if(count($result) <= 0 && 
            ( $original['criteria']['filter'][0] == '=' &&
              $original['criteria']['filter'][1] == 'user' &&
              $original['criteria']['filter'][2] == $_SESSION['phpgw_session']['account_id']
            ))
    {        
        
        if( Config::module('useCaldav') )
        {
            require_once ROOTPATH.'/modules/calendar/interceptors/DAViCalAdapter.php';
            
            $calendario = DAViCalAdapter::findCalendars();
        }
        
        if( Config::module('useCaldav') && is_array($calendario) && count($calendario) > 0)
        {     
            foreach ($calendario as $i => $v)
            {
                
                $urlA = explode('/', $v->url);
                $name = isset($v->displayname)? $v->displayname : $urlA[ (count($urlA)-2) ];
                $cal = array('name' => $name,
                             'description' =>  isset($v->description)? $v->description : $name,
                             'timezone' => isset($v->timezone) ? $v->timezone : (date_default_timezone_get()) ? date_default_timezone_get() : 'America/Sao_Paulo',
                             'dtstamp' => time().'000',
                             'location' => $urlA[ (count($urlA)-2) ]
                            );

                $calCreated =  Controller::create( array('concept' => 'calendar') , $cal );  
                
                

                $sig = array( 'user' => $_SESSION['wallet']['user']['uidNumber'],
                                  'calendar' => $calCreated['id'],
                                  'isOwner' => '1',
                                  'dtstamp' => time().'000',
                                  'fontColor' => 'FFFFFF',
                                  'backgroundColor' => '3366CC',
                                  'borderColor' => '3366CC',
                                );

                $sigCreated =  Controller::create( array('concept' => 'calendarSignature') , $sig );
               
  
               DAViCalAdapter::importCollection($v->url , $calCreated['id']);
             
            }
        }
        else
        {
         //Criaremos uma agenda paro
          $cal = array('name' => 'Calendario',
                         'description' => 'Calendario Padro',
                         'timezone' =>  (date_default_timezone_get()) ? date_default_timezone_get() : 'America/Sao_Paulo',
                         'dtstamp' => time().'000'
                        ); 
          
          $calCreated =  Controller::create( array('concept' => 'calendar') , $cal );  
          
          $sig = array( 'user' => $_SESSION['wallet']['user']['uidNumber'],
                          'calendar' => $calCreated['id'],
                          'isOwner' => '1',
                          'dtstamp' => time().'000',
                          'fontColor' => 'FFFFFF',
                          'backgroundColor' => '3366CC',
                          'borderColor' => '3366CC',
                        );
            
          $sigCreated =  Controller::create( array('concept' => 'calendarSignature') , $sig );
        }
        
        $result = Controller::find($original['URI'] , $original['properties'] ? $original['properties'] : null , $original['criteria']  );
        return false;  
    }
    
}

    public function findExternalPaticipants( &$uri , &$result , &$criteria , $original ) {   
        $newuri['concept'] = 'user';
        $newuri['service'] = 'PostgreSQL';
       
        $newCriteria = $original['criteria'];
        $valid = true;

            $newCriteria['filter'] = array('AND',$newCriteria['filter'] , array('=' , 'owner', Config::me('uidNumber')) );        
            $externalUsers = Controller::find( $newuri , $original['properties'] ? $original['properties'] : null , $newCriteria );

            if(is_array($externalUsers))
            {
                foreach ($externalUsers as $i => $v)
                    $externalUsers[$i]['isExternal'] = '1';
            }
            else
                $externalUsers = array();

            if(!is_array($result))
                    $result = array();

            return array_merge($result, $externalUsers);    
        
       
    }

    public function createSchedulableMails( &$uri , &$result , &$criteria , $original ){
	
        require_once (ROOTPATH.'/plugins/icalcreator/iCalcreator.class.php' );
        require_once (ROOTPATH.'/api/parseTPL.php' );
        $schedulable = Controller::read( array( 'concept' => 'schedulable' , 'id' => $result['id'] )); 
        $participants = Controller::find( array( 'concept' => 'participant' ) , false ,array( 'filter' => array('=', 'schedulable' ,  $result['id']) )) ; 
        
        
	if(is_array($participants) && count($participants) > 0) //Caso exista participants
	{
            $att = array();
            $attList = '<UL> ';
            $organizer = array();
            foreach ($participants as $i => $v)
			{
              	if($part['isExternal'] == 1)
                    $att[$i] =  Controller::read( array( 'concept' => 'user' , 'id' => $v['user'] , 'service' => 'PostgreSQL' ) );
                else
                    $att[$i] = Controller::read( array( 'concept' => 'user' , 'id' => $v['user'] ));
            
               $attList .= '<LI> '.$att[$i]['name'] .'</LI> ';
               
               if( isset($v['isOrganizer']) && $v['isOrganizer'] == 1)
                   $organizer = $att[$i];
               
            }
            $attList .= '</UL>';
            
            foreach ($participants as $i => $v)
			{				
                
                if($v === $organizer) //Organizador ? 
                    continue;
                
                //Criao do ical
                $ical = null;
              	$ical = new vcalendar();
				$ical->setProperty( 'method' , 'REQUEST' );			
				$vschedulable = &$ical->newComponent( 'vschedulable' );
				$vschedulable->setProperty( 'uid' , $schedulable['uid'] );
				$vschedulable->setProperty( 'dtstart', gmdate( DATE_RFC822 , (int)($schedulable['startTime'] / 1000)));
				$vschedulable->setProperty( 'dtend', gmdate( DATE_RFC822 , (int)($schedulable['endTime'] / 1000)));
				$vschedulable->setProperty( 'summary',( $schedulable['summary'] ));
				$vschedulable->setProperty( 'description', $schedulable['description']);
                $vschedulable->setProperty( 'location', $schedulable['location']);
                $params = array();
                $params['CN'] = $att[$i]['name'];
                $params['RSVP'] = 'TRUE';
                $params['ROLE'] = 'REQ-PARTICIPANT';
                if(isset($att[$i]['mail']))
                    $vschedulable->setProperty( 'attendee', $att[$i]['mail'] , $params);
                
                $vschedulable->setProperty( 'organizer', $organizer['mail'] , array('CN' => $organizer['name']) );
				///////////////////////////////////////////////////////////////////////////
                
                //Criao do E-mail
                $mail = array();
                $mail['isHtml'] = true;  
                
                $timzone = new DateTimeZone('UTC');
                $sTime = new DateTime( '@'.(int)($schedulable['startTime'] / 1000) , $timzone );
                $eTime =  new DateTime( '@'.(int)($schedulable['endTime'] / 1000) , $timzone );
                
                $mail['body'] = parseTPL::load_tpl(array( 'startDate' =>  date_format( $sTime , 'd/m/Y') ,
                                                          'startTime' =>  date_format( $sTime , 'H:i') ,
                                                          'endDate' =>  date_format( $eTime , 'd/m/Y') ,
                                                          'endTime' =>  date_format( $eTime , 'H:i') ,
                                                          'schedulableTitle' =>  $schedulable['summary'],
                                                          'schedulableLocation' =>  $schedulable['location'],
                                                          'participants' =>  $attList
                                                        ),ROOTPATH.'/api/templates/notify_create_body.tpl');
                
                //TODO: Internacionalizao do Subject
                $mail['subject'] = 'Schedulableo do Calendrio : '.$schedulable['summary'] .' @ '.date_format( $sTime , 'd/m/Y H:i') . ' - ' .  date_format( $eTime , 'd/m/Y H:i');
                $mail['from'] =  $organizer['mail'];
                $mail['to'] = $att[$i]['mail'];
                $mail['attachments'][] = array('source' => $ical->createCalendar(), 'type' => 'text/calendar' ,'disposition' => 'inline' ,'name' => 'external.ics');
                $result['participants'][$i]['sendInvite'] = Controller::create( array( 'service' => 'SMTP' ), $mail );   
	
			}         
        }
 
		
	}

    public function davcalCreateCollection( &$uri , &$params , &$criteria , $original ){	
        if( Config::module('useCaldav') )
        {
           require_once ROOTPATH.'/modules/calendar/interceptors/DAViCalAdapter.php';
           DAViCalAdapter::mkcalendar($params['location'] , $params['name'], isset($params['description']) ? $params['description'] : '' );
        }
    }
    
   public function davcalDeleteCollection( &$uri , &$params , &$criteria , $original ){	
        if( Config::module('useCaldav') )
        {
           require_once ROOTPATH.'/modules/calendar/interceptors/DAViCalAdapter.php';
           $calendar = Controller::read($uri);
           DAViCalAdapter::rmCalendar($calendar['location']);
        }
    }
	
   public function davcalUpdateCollection( &$uri , &$params , &$criteria , $original ){	
        if( Config::module('useCaldav') )
        {
           require_once ROOTPATH.'/modules/calendar/interceptors/DAViCalAdapter.php';
           if(isset($params['location']))
           {
                $calendar = Controller::read($uri);
                if($calendar['location'] !== $params['location'])
                    DAViCalAdapter::mvcalendar($calendar['location'], $params['location']);
           }
        }
    }
	
//HELPERS
    private static function decodeRepeat( $repeat , $start , $end ) {
    require_once ROOTPATH.'/plugins/when/When.php';

    $r = new When();
    $r->recur( new DateTime( '@'.$start , new DateTimeZone('UTC') ), $repeat['frequency'] );

    foreach($repeat as $rule => $value)
    {                  
            switch(strtoupper($rule))
            {
                    case "ENDTIME":
                            $r->until( new DateTime( '@'.$value ) );
                            break;
                    case "COUNT":
                            $r->count( $value );
                            break;
                    case "INTERVAL":
                            $r->interval( $value );
                            break;
                    case "BYDAY":
                            if( !is_array( $value ) )
                                $value = explode( ',' , $value );
                            $r->byday( $value );
                            break;
                    case "BYMONTHDAY":
                           if( !is_array( $value ) )
                                $value = explode(',' , $value );
                            $r->bymonthday($value);
                            break;
                    case "BYYEARDAY":
                              if( !is_array( $value ) )
                                $value = explode(',', $value );
                            $r->byyearday( $value );
                            break;
                    case "BYWEEKNO":
                             if(!is_array( $value ))
                                $value = explode( ',', $value );
                            $r->byweekno( $value );
                            break;
                    case "BYMONTH":
                             if( !is_array( $value ) )
                                $value = explode( ',', $value );
                            $r->bymonth( $value );
                            break;
                    case "BYSETPOS":
                             if( !is_array( $value ) )
                                $value = explode( ',' , $value );
                            $r->bysetpos( $value );
                            break;
                    case "WKST":
                            $r->wkst( $value );
                            break;
            }
    }

    $return = array();

    while($result = $r->next())
    { 
       $u = $result->format('U');
       if( $u  > $end ) //data da repetio atual maior que a data final da busca do usuario ?
           break;

      $return[] =  $u;
    }

    return $return;
}
    private function _makeUid() {

            $date   = date('Ymd\THisT');
            $unique = substr(microtime(), 2, 4);
            $base   = 'aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPrRsStTuUvVxXuUvVwWzZ1234567890';
            $start  = 0;
            $end    = strlen( $base ) - 1;
            $length = 6;
            $str    = null;
            for( $p = 0; $p < $length; $p++ )
              $unique .= $base{mt_rand( $start, $end )};

            return $date.$unique.'@expresso-calendar';
    }
    private function getStatus( $id ){
             $a = array(
                                            STATUS_CONFIRMED =>  'CONFIRMED',
                                            STATUS_CANCELLED =>  'CANCELLED',
                                            STATUS_TENATIVE =>   'TENATIVE',
                                            STATUS_UNANSWERED => 'NEEDS-ACTION',
                                            STATUS_DELEGATED =>  'DELEGATED'
                                            );
             return $a[ $id ];
    }
    private static function decodeAlarmType( $id ){
             $a = array(	ALARM_ALERT =>  'alert',
				ALARM_MAIL =>  'mail',
				ALARM_SMS =>   'sms' );

             return $a[ $id ];
    }
    private static function codeAlarmType( $type ){
             $a = array(	'alert' => ALARM_ALERT  ,
				'mail' => ALARM_MAIL   ,
				'sms' => ALARM_SMS   );

             return $a[ $type ];
    }
    private static function codeAlarmUnit( $u ){
		if($u === 'd') return 'days';
		if($u === 'm') return 'minutes';
		if($u === 'H') return 'hours';
	}   
  
    private static function ownerSchedulable( $id ){
        
       $isOwner = Controller::find(array('concept' => 'participant'), array('id') , 
             array('filter' => 
                 array('AND', 
                        array('=' , 'isOrganizer' , '1'),
                        array('=' , 'user'  ,$_SESSION['wallet']['user']['uidNumber'] ),
                        array('=' , 'schedulable'  ,$id )
                     )));
       
        return ( isset( $isOwner[0]['id'] ) ) ? true : false; 
    }

    private static function schedulable2calendarToObject($Schedulable)
    {
      return Controller::service('PostgreSQL')->execResultSql('SELECT calendar_to_calendar_object.id as calendar_to_calendar_Object , calendar.name as calendar_name ,calendar.location as calendar_location FROM calendar_to_calendar_object , calendar , calendar_signature' 
                .' WHERE calendar_signature.user_uidnumber = '.$_SESSION['wallet']['user']['uidNumber']
                .' AND calendar_signature.is_owner = 1'
                .' AND calendar_signature.calendar_id = calendar.id'
                .' AND calendar_to_calendar_object.calendar_id = calendar.id'
                .' AND calendar_to_calendar_object.calendar_object_id = '.addslashes($Schedulable));
    }
		   
}

?>
